neko/Dockerfile

136 lines
3.5 KiB
Docker
Raw Normal View History

2020-11-28 09:51:33 +13:00
#
# Stage 1: Build.
#
2021-02-21 01:49:06 +13:00
FROM golang:1.16-buster as build
2020-10-23 04:08:13 +13:00
WORKDIR /src
#
# install dependencies
2020-11-28 09:51:33 +13:00
ENV DEBIAN_FRONTEND=noninteractive
2021-01-18 08:47:34 +13:00
RUN set -eux; \
apt-get update; \
apt-get install -y --no-install-recommends \
libx11-dev libxrandr-dev libxtst-dev libgtk-3-dev \
2021-01-29 09:12:35 +13:00
libgstreamer1.0-dev libgstreamer-plugins-base1.0-dev; \
2020-10-23 04:08:13 +13:00
#
# clean up
apt-get clean -y; \
rm -rf /var/lib/apt/lists/* /var/cache/apt/*
2021-01-31 12:01:43 +13:00
ARG GIT_COMMIT=dev
ARG GIT_BRANCH=dev
2020-10-23 04:08:13 +13:00
#
# build server
2020-10-23 08:07:37 +13:00
COPY . .
2021-01-31 12:01:43 +13:00
RUN go get -v -t -d . && go build \
-tags browser \
-o bin/neko \
-ldflags " \
-s -w \
-X 'demodesk/neko.buildDate=`date -u +'%Y-%m-%dT%H:%M:%SZ'`' \
-X 'demodesk/neko.gitCommit=${GIT_COMMIT}' \
-X 'demodesk/neko.gitBranch=${GIT_BRANCH}' \
" \
2021-02-21 01:49:06 +13:00
cmd/neko/main.go;
2020-10-23 08:07:37 +13:00
2020-11-28 09:51:33 +13:00
#
# Stage 2: Runtime.
#
FROM debian:buster-slim as runtime
#
# set custom user
ARG USERNAME=neko
ARG USER_UID=1000
ARG USER_GID=$USER_UID
#
# install dependencies
ENV DEBIAN_FRONTEND=noninteractive
2021-01-18 08:47:34 +13:00
RUN set -eux; \
apt-get update; \
apt-get install -y --no-install-recommends \
wget ca-certificates supervisor \
pulseaudio dbus-x11 xserver-xorg-video-dummy xserver-xorg-input-void \
libcairo2 libxcb1 libxrandr2 libxv1 libopus0 libvpx5 \
#
2021-01-29 09:12:35 +13:00
# file chooser handler, clipboard
xdotool xclip \
2021-01-18 08:47:34 +13:00
#
# gst
gstreamer1.0-plugins-base gstreamer1.0-plugins-good \
gstreamer1.0-plugins-bad gstreamer1.0-plugins-ugly \
gstreamer1.0-pulseaudio; \
2020-11-28 09:51:33 +13:00
#
# create a non-root user
groupadd --gid $USER_GID $USERNAME; \
useradd --uid $USER_UID --gid $USERNAME --shell /bin/bash --create-home $USERNAME; \
adduser $USERNAME audio; \
adduser $USERNAME video; \
adduser $USERNAME pulse; \
#
# setup pulseaudio
mkdir -p /home/$USERNAME/.config/pulse/; \
echo "default-server=unix:/tmp/pulseaudio.socket" > /home/$USERNAME/.config/pulse/client.conf; \
#
# workaround for an X11 problem: http://blog.tigerteufel.de/?p=476
mkdir /tmp/.X11-unix; \
chmod 1777 /tmp/.X11-unix; \
chown $USERNAME /tmp/.X11-unix/; \
#
# make directories for neko
mkdir -p /etc/neko /var/www /var/log/neko; \
chmod 1777 /var/log/neko; \
chown $USERNAME /var/log/neko/; \
chown -R $USERNAME:$USERNAME /home/$USERNAME; \
#
2021-04-20 03:39:09 +12:00
# install fonts
apt-get install -y --no-install-recommends \
# Emojis
fonts-noto-color-emoji \
# Chinese fonts
fonts-arphic-ukai fonts-arphic-uming \
# Japanese fonts
fonts-ipafont-mincho fonts-ipafont-gothic \
# Korean fonts
fonts-unfonts-core \
# Indian fonts
fonts-indic; \
#
2020-11-28 09:51:33 +13:00
# clean up
apt-get clean -y; \
rm -rf /var/lib/apt/lists/* /var/cache/apt/*
#
2021-01-13 04:37:44 +13:00
# copy runtime configs
2020-11-28 09:51:33 +13:00
COPY runtime/dbus /usr/bin/dbus
COPY runtime/default.pa /etc/pulse/default.pa
COPY runtime/supervisord.conf /etc/neko/supervisord.conf
COPY runtime/xorg.conf /etc/neko/xorg.conf
2021-01-13 04:37:44 +13:00
#
# copy runtime folders
2021-04-20 03:39:09 +12:00
COPY --chown=$USERNAME runtime/icon-theme /home/$USERNAME/.icons/default
COPY runtime/fontconfig/* /etc/fonts/conf.d/
COPY runtime/fonts /usr/local/share/fonts
2021-01-13 04:37:44 +13:00
2020-11-28 09:51:33 +13:00
#
# set default envs
ENV USER=$USERNAME
ENV DISPLAY=:99.0
2021-03-17 03:24:58 +13:00
ENV NEKO_SERVER_BIND=:8080
2020-11-28 09:51:33 +13:00
#
# copy executabe from previous stage
COPY --from=build /src/bin/neko /usr/bin/neko
2021-03-20 03:04:01 +13:00
#
# add healthcheck
HEALTHCHECK --interval=10s --timeout=5s --retries=8 \
CMD wget -O - http://localhost:${NEKO_SERVER_BIND#*:}/api/health || exit 1
2020-11-28 09:51:33 +13:00
#
# run neko
CMD ["/usr/bin/supervisord", "-c", "/etc/neko/supervisord.conf"]